Attribute VB_Name = "Module2"
'------------- Anfang Projektdatei Projekt1.vbp -------------
 
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
 
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !
 
'--------- Anfang Formular "Form1" alias Form1.frm  ---------
 
 
'Autor: Mario Zeller
'Email: interlux@web.de
 
Option Explicit
 
Private Sub cmdOpen_Click()
  Dim MP3FileName$, Mp3FileNumber, Mp3FileContent$
  Dim ID3Position As Long, ID3Length$, lngID3Length As Long
  Dim ID3Version$, ID3V2Tag$
  
  On Error Resume Next
    
    'ffnen-Dialog
    lstID3V2Info.Clear
    File.DefaultExt = ".MP3"
    File.DialogTitle = "MP3 ffnen"
    File.Filter = "MP3-Dateien|*.MP3"
    File.ShowOpen
    
    If Dir$(File.FileName) <> "" Then
      lblStatus.Caption = "MP3 ffnen..."
      
      MP3FileName$ = File.FileName
      Mp3FileNumber = FreeFile
      'MP3 einlesen...
      Open MP3FileName$ For Binary As Mp3FileNumber
        lblStatus.Caption = "Bitte warten, lese MP3 ein..."
        Mp3FileContent$ = String$(LOF(Mp3FileNumber), "!")
      Get Mp3FileNumber, , Mp3FileContent$
      Close Mp3FileNumber
      
      'ID3V2-Tag suchen
      lblStatus.Caption = "Bitte warten, suche ID3V2-Tag"
      ID3Position = InStr(Mp3FileContent$, "ID3")
      If ID3Position = 0 Then
        lblStatus.Caption = "Kein ID3V2-Tag vorhanden"
        Exit Sub
      End If
      
      'Tag gefunden, weiter gehts!
      lblStatus.Caption = "ID3V2-Tag gefunden!"
      ID3Version$ = Mid$(Mp3FileContent$, ID3Position + 3, 2)
      
      'Versionkontrolle
      If Asc(Left$(ID3Version$, 1)) <> 2 And _
        Asc(Left$(ID3Version$, 1)) <> 3 And _
        Asc(Left$(ID3Version$, 1)) <> 4 Then
          lblStatus.Caption = "Falsche Version! (" + _
                              Trim$(Str$(Asc(Left$(ID3Version$, _
                              1)))) + ")"
          Exit Sub
      End If
      
      'Version anzeigen
      lstID3V2Info.AddItem "ID3V2-Version:" + _
                      Str$(Asc(Left$(ID3Version$, 1))) + "." + _
                      Trim$(Str$(Asc(Right$(ID3Version$, 1))))
                      
      'Lnge bestimmen
      ID3Length$ = Mid$(Mp3FileContent$, ID3Position + 6, 4)
      lngID3Length = 256 * 8 * 8 * Asc(Left$(ID3Length$, 1)) + _
                     256 * 8 * Asc(Mid$(ID3Length$, 2, 1)) + _
                     256 * Asc(Mid$(ID3Length$, 3, 1)) + _
                     Asc(Mid$(ID3Length$, 4, 1))
      lstID3V2Info.AddItem "Lnge des ID3V2-Tags:" + _
                           Str$(lngID3Length) + " Byte"
                           
      ID3V2Tag$ = Mid$(Mp3FileContent$, ID3Position, _
                       lngID3Length + 10)
                       
      Mp3FileContent$ = ""
      
      'Nach Extended Header suchen...
      If Asc(Mid$(ID3V2Tag$, 6, 1)) Or 4 = True Then
        lstID3V2Info.AddItem "Extended Header gefunden"
        ID3V2Tag$ = Mid$(ID3V2Tag$, 10)
      End If
      ID3V2Tag$ = Mid$(ID3V2Tag$, 11)
      
      'Nun Frame fr Frame abarbeiten...
      Dim FrameName$
      Dim FrameLen$, lngFrameLen
      Dim FrameFlags$, Frame$
      
      Do
        'ID3V2.3
        If Asc(Left$(ID3Version$, 1)) = 3 Or _
           Asc(Left$(ID3Version$, 1)) = 4 Then
          
          'Frame-Header auslesen
          FrameName$ = Left$(ID3V2Tag$, 4)
          
          'Wenn es sich um den Footer handelt, dann sind wir
          'fertig!
          If Left$(FrameName$, 3) = "3DI" Then Exit Do
          FrameLen$ = Mid$(ID3V2Tag$, 5, 4)
          lngFrameLen = 256 * 8 * 8 * Asc(Left$(FrameLen$, 1)) _
                        + 256 * 8 * Asc(Mid$(FrameLen$, 2, 1)) _
                        + 256 * Asc(Mid$(FrameLen$, 3, 1)) + _
                        Asc(Mid$(FrameLen$, 4, 1))
          
          FrameFlags$ = Mid$(ID3V2Tag$, 9, 2)
          ID3V2Tag$ = Mid$(ID3V2Tag$, 11)
          
          'Frame-Content bestimmen
          Select Case FrameName$
            Case "PCNT": Frame$ = "Play Counter:"
            Case "TRCK": Frame$ = "Track:"
            Case "TENC": Frame$ = "Encoded von:"
            Case "WXXX": Frame$ = "Link:"
            Case "TCOP": Frame$ = "Copyright (c):"
            Case "TOPE": Frame$ = "Ursprnglicher Knstler:"
            Case "TCOM": Frame$ = "Composer:"
            Case "TCON": Frame$ = "Genre:"
            Case "COMM": Frame$ = "Kommentar:"
            Case "TYER": Frame$ = "Jahr:"
            Case "TALB": Frame$ = "Album:"
            Case "TPE1": Frame$ = "Knstler:"
            Case "TIT2": Frame$ = "Titel:"
            Case "TLAN": Frame$ = "Sprache:"
            Case "TLEN": Frame$ = "Lnge:"
            Case "TMED": Frame$ = "Medientyp:"
            Case "TPUB": Frame$ = "Publisher:"
            Case "TSSE": Frame$ = "Decoding-Software:"
            Case Else:   Frame$ = "Unbekanntes Frame(" + _
                                   FrameName$ + "):"
          End Select
          
          If Left$(ID3V2Tag$, 1) = Chr$(0) Then
            lstID3V2Info.AddItem Frame$ + " " + _
                                 Mid$(ID3V2Tag$, 2, _
                                 lngFrameLen - 1)
          Else
            lstID3V2Info.AddItem Frame$ + " " + _
                                 Left$(ID3V2Tag$, _
                                 lngFrameLen)
          End If
          
          ID3V2Tag$ = Mid$(ID3V2Tag$, lngFrameLen + 1)
        
        'ID3V2.2
        ElseIf Asc(Left$(ID3Version$, 1)) = 2 Then
          
          'Frame-Header auslesen
          FrameName$ = Left$(ID3V2Tag$, 3)
          
          'Wenn es sich um den Footer handelt, dann sind wir
          'fertig!
          If FrameName$ = "3DI" Then Exit Do
          FrameLen$ = Mid$(ID3V2Tag$, 4, 3)
          lngFrameLen = 256 * 8 * Asc(Left$(FrameLen$, 1)) + _
                        256 * Asc(Mid$(FrameLen$, 2, 1)) + _
                        Asc(Mid$(FrameLen$, 3, 1))
                        
          ID3V2Tag$ = Mid$(ID3V2Tag$, 7)
          
          'Frame-Content bestimmen
          Select Case FrameName$
            Case "TRK": Frame$ = "Track:"
            Case "TEN": Frame$ = "Encoded von:"
            Case "TCR": Frame$ = "Copyright (c):"
            Case "TOA": Frame$ = "Ursprnglicher Knstler:"
            Case "TCM": Frame$ = "Composer:"
            Case "TCO": Frame$ = "Genre:"
            Case "COM": Frame$ = "Kommentar:"
            Case "TYE": Frame$ = "Jahr:"
            Case "TAL": Frame$ = "Album:"
            Case "TP1": Frame$ = "Knstler:"
            Case "TT2": Frame$ = "Titel:"
            Case "TLA": Frame$ = "Sprache:"
            Case "TMT": Frame$ = "Medientyp:"
            Case "TSS": Frame$ = "Decoding-Software:"
            Case Else:  Frame$ = "Unbekanntes Frame(" + _
                                 FrameName$ + "):"
          End Select
          
          If Left$(ID3V2Tag$, 1) = Chr$(0) Then
            lstID3V2Info.AddItem Frame$ + " " + _
                                 Mid$(ID3V2Tag$, _
                                 2, lngFrameLen - 1)
          Else
            lstID3V2Info.AddItem Frame$ + " " + _
                                 Left$(ID3V2Tag$, _
                                 lngFrameLen)
          End If
          
          ID3V2Tag$ = Mid$(ID3V2Tag$, lngFrameLen + 1)
          
        End If
      Loop Until Len(ID3V2Tag$) = 0
      lblStatus.Caption = "Bereit!"
    End If
End Sub
 
Private Sub Form_Load()
  lblStatus.Caption = "Bitte eine MP3 ffnen"
End Sub
'---------- Ende Formular "Form1" alias Form1.frm  ----------
' Die Komponente COMDLG32.OCX wird bentigt.
'-------------- Ende Projektdatei Projekt1.vbp --------------



 
Verwendete API - Aufrufe:

 



 Windows/VB-Version
Win32s
Win95
Win98
WinME
WinNT4
Win2000
WinXP
VB4







VB5







VB6








Hat dieser Tipp auf Ihrem Betriebsystem und mit Ihrer VB-Version funktioniert?
 Ja , funktioniert!
Windows -Version:
 
 Nein, funktioniert nicht bei mir!
VB -Version:
 











Ihre Meinung


Falls Sie Fragen zu oder Erfahrungen mit diesem Tipp haben, dann sollten Sie diese hier posten. Fr alles weitere melden Sie sich bitte in einem zum Thema passendem Forum.
Ihr Name:

Ihre E - Mailadresse:
 
Ihre Frage/Ihr Kommentar:

Ja, ich mchte weitere Beitrge per EMail erhalten












 Von Mario Zeller am 16.06.2002 um 17:53 mario@activevb.de
Das Programm kann nur Dateien mit dem ID3V2-Tag anzeigen. Fr den V1-Tag muss man den Tipp 242 benutzen. Das mit den 4*7 Bit stimmt, ich arbeite an einer Lsung.
Von Bully am 22.04.2002 um 20:00 Bully@schmeissfliege.de
Bei mir zeigt das Ding jedesmal an, das kein Tag vorhanden ist. In seltenen Fllen falsche Version (x). Arbeite mit WinXP und VB6. Bully
Von Sascha Monetha am 24.12.2001 um 16:52 info@monetha.de
Ist es mglich in VBA mp3-Datei abzuspielen? Wenn ja wie funktioniert das???
Von Michael am 13.12.2001 um 23:57 support@id3-tagit.de
Rdiger hat Recht. Die Gre des gesamten ID3V2-Tags ist als 4*7 Bit codiert. Die Framegren sind in der Version 2.3 als 4*8 Bit codiert (nicht wundern, ist einfach so spezifiziert worden) und in der Version 2.4 als 4*7 Bit.
Von Rdiger Busch am 04.09.2001 um 13:21 r.busch@hamburg.de
laut meiner Informationen ist die ID3 size 4 * 7 bit und nicht 4 * 8 bit lang. Aus diesem Grund wir die Lnge des ID3V2-Tags hier falsch angezeigt.

Von Pasce am 14.9.2002 um 9:30 pasce00@hotmail.com
Bei mir funzt es eigentlich gut, nur die Felder "Kommentar" und "Link" knnen nicht ausgelesen werden! kann mir da jemand helfen?








Drucken
Fehlerbericht






Autor: Mario Zeller
Erstellt: 11.01.2003
Aktualisierung: 11.01.2003
E -Mail: interlux@ web.de

Nach oben





Copyright  1998-2003 by ActiveVB.de. Alle Rechte vorbehalten.

