Attribute VB_Name = "Module2"
'Better Audio Manager - a better audio manager for the Nokia 5510
'Copyright (C) 2003  Doug McPherson - bam@mcpherson.id.au

'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.

'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.

'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

Option Explicit


Function MakeLSETag(ID3DAta As ID3DataType) As String

Dim strHeader As String

    Dim Title As String
    Dim artist As String
    
    Title = Trim$(ID3DAta.Title)
    artist = Trim$(ID3DAta.artist)
    
    strHeader = String(384, Chr$(0))
    
    'copy(strHeader,"ID3",3)
    Mid(strHeader, 1) = "ID3"
    '*(buf+3) = 0x03;
    Mid(strHeader, 4) = Chr(&H3)
    '*(buf+8) = 0x02;
    Mid(strHeader, 9) = Chr(&H2)
    'bcopy("vTIT2",buf+9,5);
    Mid(strHeader, 10) = "vTIT2"
    '*(buf+17) = lengthTitle+1;
    Mid(strHeader, 18) = Chr(Len(Title) + 1)
    'bcopy(title, buf+21, lengthTitle);
    
    Mid(strHeader, 22) = Title
    
    'bcopy("TPE1", buf+21+lengthTitle, 4);
    Mid(strHeader, 22 + Len(Title)) = "TPE1"
    
    '*(buf+28+lengthTitle) = lengthArtist+1;
    Mid(strHeader, 29 + Len(Title)) = Chr(Len(artist) + 1)
    
    'bcopy(artist, buf+32+lengthTitle, lengthArtist);
    Mid(strHeader, 32 + Len(Title)) = artist '33
    
    'bcopy("TLEN", buf+32+lengthTitle+lengthArtist, 4);
    Mid(strHeader, 33 + Len(Title) + Len(artist)) = "TLEN"
    '*(buf+39+lengthTitle+lengthArtist) = 0x06;
    Mid(strHeader, 40 + Len(Title) + Len(artist)) = Chr(&H6)

    MakeLSETag = strHeader
    
    

End Function


Function MakeLSEHEader() As String

'Derived from Nokryptia source
' GNU GENERAL PUBLIC LICENSE
'http://tuxmobil.org/nokryptia.html


    'if (verbose) cout << "Writing LockStream key to output" << endl;

    '/* allocate memory */
    'buf = new char[512];
    Dim strHeader As String
    strHeader = String(512, Chr$(&H0))

    '/* clear the buffer */
    'for (i = 0; i < 512; i++) {
    '    *(buf+i) = 0;
    '}

    '/* generate the data */
    'bcopy("LockStream Embedded\0d",buf,21);
    Mid(strHeader, 1) = "LockStream Embedded" + Chr(&H0) + "d"
    '*(buf+25) = 0x02;
    Mid(strHeader, 26) = Chr(&H2)
    '*(buf+32) = 0x02;
    Mid(strHeader, 33) = Chr(&H2)
    '*(buf+37) = 0x02;
    Mid(strHeader, 38) = Chr(&H2)
    '*(buf+104) = 0x02;
    Mid(strHeader, 105) = Chr(&H2)
    '*(buf+108) = 0x13;
    Mid(strHeader, 109) = Chr(&H15)  'its 0x15 on my 5510 ?
    '*(buf+112) = 0x80;
    Mid(strHeader, 113) = Chr(&H80)

    '/* write the header to the file */
    'fwrite(buf,512,1,outfile);

    '/* clean up the memory */
    'delete[] buf;
    
    MakeLSEHEader = strHeader

End Function
Sub GetTagStartAndLength(FileContent$, TagStart, TagLength)
Dim ID3position As Long
Dim ID3Version As String
Dim ID3Length As String
Dim lngID3Length As Long

    ID3position = InStr(FileContent$, "ID3")
    If ID3position = 0 Then
        'status = "No ID3V2-Tag available" '"Kein ID3V2-Tag vorhanden"
        TagStart = 0
        TagLength = 0
        Exit Sub
    End If
      
    
    'Tag found, on we go!
    'status = "ID3V2-Tag found!" '"ID3V2-Tag gefunden!"
    ID3Version$ = Mid$(FileContent$, ID3position + 3, 2)
      
    'Version Control
    'If Asc(Left$(ID3Version$, 1)) <> 2 And _
    '   Asc(Left$(ID3Version$, 1)) <> 3 And _
    '   Asc(Left$(ID3Version$, 1)) <> 4 Then
    '   status = "Invalid Version! (" + _
    '                          Trim$(Str$(Asc(Left$(ID3Version$, _
    '                          1)))) + ")"
    '      Exit Sub
    '  End If
      
    'Show Version
    'lstID3V2Info.AddItem "ID3V2-Version:" + _
    '                Str$(Asc(Left$(ID3Version$, 1))) + "." + _
    '                Trim$(Str$(Asc(Right$(ID3Version$, 1))))
      
      
    'Lnge bestimmen
    'determine length
    ID3Length$ = Mid$(FileContent$, ID3position + 6, 4)
    lngID3Length = 256 * 8 * 8 * CLng(Asc(Left$(ID3Length$, 1)))
    lngID3Length = lngID3Length + 256 * 8 * CLng(Asc(Mid$(ID3Length$, 2, 1)))
    lngID3Length = lngID3Length + 256 * CLng(Asc(Mid$(ID3Length$, 3, 1)))
    lngID3Length = lngID3Length + CLng(Asc(Mid$(ID3Length$, 4, 1)))
      
    'lstID3V2Info.AddItem "Length of ID3V2-Tags:" + _
    '                     Str$(lngID3Length) + " Byte"
    
    TagStart = ID3position
    TagLength = lngID3Length + 10
                           
    'ID3V2Tag$ = Mid$(Mp3FileContent$, ID3Position, _
    '                   lngID3Length + 10)
End Sub
