Attribute VB_Name = "Module3"
Option Explicit
'This module is explicitly not covered by the GPL.
'It is free source with no restrictions imposed by it's author (Mario Zeller)
'I don't have the right to restrict its licence to the GPL (Doug McPherson)

Sub GetMP3v2Tags(Mp3FileContent$, status As String, ID3DAta As ID3DataType, TagLength As Long)

'Taken from the following site: (and translated from the German !)
'http://www.activevb.de/tipps/vb6tipps/tipp0408.html
'Autor: Mario Zeller
'Email: interlux@web.de



  Dim ID3position As Long
  Dim ID3Length$
  Dim lngID3Length As Long
  Dim ID3Version$
  Dim ID3V2Tag$
  Dim FrameContent$

      ID3position = InStr(Mp3FileContent$, "ID3")
      If ID3position = 0 Then
        status = "No ID3V2-Tag available" '"Kein ID3V2-Tag vorhanden"
        Exit Sub
      End If
      
      'Tag gefunden, weiter gehts!
      'Tag found, on we go!
      status = "ID3V2-Tag found!" '"ID3V2-Tag gefunden!"
      ID3Version$ = Mid$(Mp3FileContent$, ID3position + 3, 2)
      
      'Version Control
      If Asc(Left$(ID3Version$, 1)) <> 2 And _
        Asc(Left$(ID3Version$, 1)) <> 3 And _
        Asc(Left$(ID3Version$, 1)) <> 4 Then
          status = "Invalid Version! (" + _
                              Trim$(Str$(Asc(Left$(ID3Version$, _
                              1)))) + ")"
          Exit Sub
      End If
      
      'Show Version
      'lstID3V2Info.AddItem "ID3V2-Version:" + _
      '                Str$(Asc(Left$(ID3Version$, 1))) + "." + _
      '                Trim$(Str$(Asc(Right$(ID3Version$, 1))))
      
      
      'Lnge bestimmen
      'determine length
      ID3Length$ = Mid$(Mp3FileContent$, ID3position + 6, 4)
      lngID3Length = 256 * 8 * 8 * CLng(Asc(Left$(ID3Length$, 1)))
      lngID3Length = lngID3Length + 256 * 8 * CLng(Asc(Mid$(ID3Length$, 2, 1)))
      lngID3Length = lngID3Length + 256 * CLng(Asc(Mid$(ID3Length$, 3, 1)))
      lngID3Length = lngID3Length + CLng(Asc(Mid$(ID3Length$, 4, 1)))
      
      'lstID3V2Info.AddItem "Length of ID3V2-Tags:" + _
      '                     Str$(lngID3Length) + " Byte"
      TagLength = lngID3Length
                           
      ID3V2Tag$ = Mid$(Mp3FileContent$, ID3position, _
                       lngID3Length + 10)
                       
      'Mp3FileContent$ = ""
      
      'Nach Extended Header suchen...
      'Look for Extended Header
      If Asc(Mid$(ID3V2Tag$, 6, 1)) Or 4 = True Then
        'lstID3V2Info.AddItem "Extended Header found"
        ID3V2Tag$ = Mid$(ID3V2Tag$, 10)
      End If
      ID3V2Tag$ = Mid$(ID3V2Tag$, 11)
      
      'Nun Frame fr Frame abarbeiten...
      'Now Frame by Frame process...
      Dim FrameName$
      Dim FrameLen$
      Dim lngFrameLen
      Dim FrameFlags$, Frame$
      
      Do
        'ID3V2.3
        If Asc(Left$(ID3Version$, 1)) = 3 Or _
           Asc(Left$(ID3Version$, 1)) = 4 Then
          
          'Frame-Header auslesen
          'Pick out Frame headers
          FrameName$ = Left$(ID3V2Tag$, 4)
          
          'Wenn es sich um den Footer handelt, dann sind wir
          'fertig!
          ' if it around the Footer acts, then we are finished!
          If Left$(FrameName$, 3) = "3DI" Then Exit Do
          FrameLen$ = Mid$(ID3V2Tag$, 5, 4)
          If Len(FrameLen$) = 4 Then
            lngFrameLen = 256 * 8 * 8 * CLng(Asc(Left$(FrameLen$, 1))) _
                          + 256 * 8 * CLng(Asc(Mid$(FrameLen$, 2, 1))) _
                          + 256 * CLng(Asc(Mid$(FrameLen$, 3, 1))) + _
                          CLng(Asc(Mid$(FrameLen$, 4, 1)))
          Else
            lngFrameLen = 0
          End If
          
          FrameFlags$ = Mid$(ID3V2Tag$, 9, 2)
          ID3V2Tag$ = Mid$(ID3V2Tag$, 11)
          
          'Frame-Content bestimmen
          'Determine frame content
          
          If lngFrameLen > 0 Then
            If Left$(ID3V2Tag$, 1) = Chr$(0) Then
              FrameContent$ = Mid$(ID3V2Tag$, 2, (lngFrameLen - 1))
            Else
              FrameContent$ = Left$(ID3V2Tag$, lngFrameLen)
            End If
          Else
            FrameContent$ = ""
          End If
          
          Dim pos As Long
          
          Dim FoundTitleTag As Integer
          FoundTitleTag = False
          
          Select Case FrameName$
            Case "PCNT": Frame$ = "Play Counter:"
            Case "TRCK": Frame$ = "Track:"
            Case "TENC": Frame$ = "Encoded by:"
            Case "WXXX": Frame$ = "Link:"
            Case "TCOP": Frame$ = "Copyright (c):"
            Case "TOPE": Frame$ = "Original Artist:"
            Case "TCOM": Frame$ = "Composer:"
            Case "TCON": Frame$ = "Genre:"
            Case "COMM": Frame$ = "Comment:"
                         ID3DAta.Notes = (Left$(FrameContent$, 30))
                         pos = InStr(ID3DAta.Notes, Chr(0))
                         If pos > 0 Then ID3DAta.Notes = Left$(ID3DAta.Title, pos - 1)
            Case "TYER": Frame$ = "Year:"
                         ID3DAta.Year = Trim$(Left$(FrameContent$, 4))
                         pos = InStr(ID3DAta.Year, Chr(0))
                         If pos > 0 Then ID3DAta.Year = Left$(ID3DAta.Year, pos - 1)
            Case "TALB": Frame$ = "Album:"
                         ID3DAta.Album = Trim$(Left$(FrameContent$, 30))
                         pos = InStr(ID3DAta.Album, Chr(0))
                         If pos > 0 Then ID3DAta.Album = Left$(ID3DAta.Album, pos - 1)
            Case "TPE1": Frame$ = "Artist:"
                         ID3DAta.artist = Trim$(Left$(FrameContent$, 30))
                         pos = InStr(ID3DAta.artist, Chr(0))
                         If pos > 0 Then ID3DAta.artist = Left$(ID3DAta.artist, pos - 1)
            Case "TIT2": Frame$ = "Title:"
                         ID3DAta.Title = Trim$(Left$(FrameContent$, 30))
                         pos = InStr(ID3DAta.Title, Chr(0))
                         If pos > 0 Then ID3DAta.Title = Left$(ID3DAta.Title, pos - 1)
                         FoundTitleTag = True
            Case "TLAN": Frame$ = "Language:"
            Case "TLEN": Frame$ = "Length:"
            Case "TMED": Frame$ = "Type of medium:"
            Case "TPUB": Frame$ = "Publisher:"
            Case "TSSE": Frame$ = "Decoding-Software:"
            Case Else:   Frame$ = "Unknown Frame(" + _
                                   FrameName$ + "):"
          End Select
          
          ID3V2Tag$ = Mid$(ID3V2Tag$, lngFrameLen + 1)
        
        'ID3V2.2
          ElseIf Asc(Left$(ID3Version$, 1)) = 2 Then
          
          'Frame-Header auslesen
          FrameName$ = Left$(ID3V2Tag$, 3)
          
          'Wenn es sich um den Footer handelt, dann sind wir
          'fertig!
          If FrameName$ = "3DI" Then Exit Do
          FrameLen$ = Mid$(ID3V2Tag$, 4, 3)
          lngFrameLen = 256 * 8 * Asc(Left$(FrameLen$, 1)) + _
                        256 * Asc(Mid$(FrameLen$, 2, 1)) + _
                        Asc(Mid$(FrameLen$, 3, 1))
                        
          ID3V2Tag$ = Mid$(ID3V2Tag$, 7)
          
          If Left$(ID3V2Tag$, 1) = Chr$(0) Then
            FrameContent$ = Mid$(ID3V2Tag$, 2, lngFrameLen - 1)
          Else
            FrameContent$ = Left$(ID3V2Tag$, lngFrameLen)
          End If
          
          'Frame-Content bestimmen
          Select Case FrameName$
            Case "TRK": Frame$ = "Track:"
            Case "TEN": Frame$ = "Encoded by:"
            Case "TCR": Frame$ = "Copyright (c):"
            Case "TOA": Frame$ = "Original Artist:"
            Case "TCM": Frame$ = "Composer:"
            Case "TCO": Frame$ = "Genre:"
            Case "COM": Frame$ = "Comment:"
                        ID3DAta.Notes = Mid$(FrameContent$, 30)
            Case "TYE": Frame$ = "Year:"
                        ID3DAta.Year = Mid$(FrameContent$, 4)
            Case "TAL": Frame$ = "Album:"
                        ID3DAta.Album = Mid$(FrameContent$, 30)
            Case "TP1": Frame$ = "Artist:"
                        ID3DAta.artist = Mid$(FrameContent$, 30)
            Case "TT2": Frame$ = "Title:"
                        ID3DAta.Title = Mid$(FrameContent$, 30)
            Case "TLA": Frame$ = "Language:"
            Case "TMT": Frame$ = "Media type:"
            Case "TSS": Frame$ = "Decoding-Software:"
            Case Else:  Frame$ = "Unknown Frame(" + _
                                 FrameName$ + "):"
          End Select
          
          ID3V2Tag$ = Mid$(ID3V2Tag$, lngFrameLen + 1)
          
        End If
      Loop Until Len(ID3V2Tag$) = 0
      
      If FoundTitleTag Then
        status = "Bereit!"
    Else
        status = ""
    End If
            
End Sub


